import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by thook on 10/7/15.
 */
public class HamletParser {

    private String hamletData;
    private String result;

    public HamletParser() {
        this.hamletData = loadFile();
    }

    private String loadFile() {
        ClassLoader classLoader = getClass().getClassLoader();
        File file = new File(classLoader.getResource("hamlet.txt").getFile());
        StringBuilder result = new StringBuilder("");

        try (Scanner scanner = new Scanner(file)) {
            while (scanner.hasNextLine()) {
                String line = scanner.nextLine();
                result.append(line).append("\n");
            }

            scanner.close();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return result.toString();
    }

    public String getHamletData() {
        return hamletData;
    }

    public String changeHamlet(String h) {
        StringBuffer sb = new StringBuffer();
        Pattern p = Pattern.compile("Hamlet|HAMLET");
        Matcher m = p.matcher(h);
        while (m.find()) {
            m.appendReplacement(sb, Matcher.quoteReplacement("Leon"));
        }
        m.appendTail(sb);
        result = sb.toString();
        return result;

    }

    public String changeHoratio(String h){
        StringBuffer sb = new StringBuffer();
        Pattern p = Pattern.compile("Horatio|HORATIO");
        Matcher m = p.matcher(h);
        while (m.find()) {
            m.appendReplacement(sb, Matcher.quoteReplacement("Tariq"));
        }
        m.appendTail(sb);
        result = sb.toString();
        return result;
    }
}